package info.aspirecn.iov.sjjh.supplier10000040.sftp;

import info.aspirecn.iov.sjjh.supplier10000040.process.IllegalInfoProcessor;
import lombok.extern.slf4j.Slf4j;
import org.apache.camel.LoggingLevel;
import org.apache.camel.builder.RouteBuilder;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

/**
 * @description:
 * @author: xusonglin
 * @create: 2020/4/25 21:08
 * @version: V1.0
 **/
@Slf4j
@Component
public class IllegalInfoDownloadRoute extends RouteBuilder {
    @Value("${ftpDownload.route}")
    private String ftpDownloadRoute;

    @Value("${localDir.download}")
    private String localDownloadDir;

    @Autowired
    private IllegalInfoProcessor illegalInfoProcessor;

    @Override
    public void configure() {
        downloadRoute();
        parseRoute();
    }

    /**
     * 下载路由
     */
    private void downloadRoute() {
        from(ftpDownloadRoute).to("file:" + localDownloadDir).log(LoggingLevel.INFO, log, "supplier10000040.Downloaded illegalInfo result ${file:name} complete.");
    }

    /**
     * 解析路由
     */
    private void parseRoute() {
        from("file:" + localDownloadDir).process(illegalInfoProcessor).log(LoggingLevel.INFO, log, "supplier10000040.Read illegalInfo Result ${file:name} complete.");
    }
}
