package info.aspirecn.iov.sjjh.supplier10000040.util;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import io.searchbox.client.JestClient;
import io.searchbox.core.UpdateByQuery;
import io.searchbox.core.UpdateByQueryResult;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

@Slf4j
@Component
public class EsOpeateUtils {
    @Value("${index}")
    String index;
    @Autowired
    private JestClient jestClient;

    @Autowired
    private ObjectMapper objectMapper;


    public boolean updateByQuery(String traceId, String ifCj, int isCharge, String responseCode) throws JsonProcessingException {
        String source = "{\"script\": {\n" +
                "    \"source\": \"ctx._source['MG-IfCj']='" + ifCj + "';ctx._source['MG-Upstream-ResponseCode']='" + responseCode + "';ctx._source['MG-IsCharge']=" + isCharge + "\"" +
                "  } ,\"query\": {    \"bool\": {  \"must\": [       {\"term\" : {\"traceId\" : \"" + traceId + "\"}}, {\"term\": {\"ApplicationName.keyword\":\"iov-sjjh-servicenode-supplier-10000040\"}} \n" +
                "        \n" +
                "        ]\n" +
                "      }\n" +
                "    }}";
        log.info("source:{}", source);
     /*   UpdateByQueryScript UpdateByQueryScript = new UpdateByQueryScript(source,traceId);
        String builderStr = objectMapper.writeValueAsString(UpdateByQueryScript);*/
        UpdateByQuery updateByQuery = new UpdateByQuery.Builder(source).addIndex(index).build();
        UpdateByQueryResult result = null;
        try {
            result = jestClient.execute(updateByQuery);
            log.info("result:{}", result);
            long updatedCount = result.getUpdatedCount();
            if (result.isSucceeded() && updatedCount != 0L) {
                return true;
            }
        } catch (Exception e) {
            log.error("ES更新log异常Exception：", e);
        }
        return false;
    }
}
